// DO-NOT-REMOVE begin-copyright-block 
//
// Redistributions of any form whatsoever must retain and/or include the
// following acknowledgment, notices and disclaimer:
//
// This product includes software developed by Carnegie Mellon University.
//
// Copyright 2010 by Mohammad Alisafaee, Eric Chung, Michael Ferdman, Brian Gold,
// Jangwoo Kim, Pejman Lotfi-Kamran, Onur Kocberber, Ippokratis Pandis, 
// Djordje Jevdjic, Jared Smolens, Stephen Somogyi, Evangelos Vlachos, 
// Stavros Volos, Jason Zebchuk, Babak Falsafi, Nikos Hardavellas and Tom Wenisch 
// for the SimFlex Project, Computer Architecture Lab at Carnegie Mellon,
// Carnegie Mellon University.
//
// For more information, see the SimFlex project website at:
//   http://www.ece.cmu.edu/~simflex
//
// You may not use the name "Carnegie Mellon University" or derivations
// thereof to endorse or promote products derived from this software.
//
// If you modify the software you must place a notice on or within any
// modified version provided or made available to any third party stating
// that you have modified the software.  The notice shall include at least
// your name, address, phone number, email address and the date and purpose
// of the modification.
//
// THE SOFTWARE IS PROVIDED "AS-IS" WITHOUT ANY WARRANTY OF ANY KIND, EITHER
// EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT LIMITED TO ANY WARRANTY
// THAT THE SOFTWARE WILL CONFORM TO SPECIFICATIONS OR BE ERROR-FREE AND ANY
// IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
// TITLE, OR NON-INFRINGEMENT.  IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY
// BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO DIRECT, INDIRECT,
// SPECIAL OR CONSEQUENTIAL DAMAGES, ARISING OUT OF, RESULTING FROM, OR IN
// ANY WAY CONNECTED WITH THIS SOFTWARE (WHETHER OR NOT BASED UPON WARRANTY,
// CONTRACT, TORT OR OTHERWISE).
//
// DO-NOT-REMOVE end-copyright-block   

#ifndef FLEXUS_DECOUPLED_FEEDER_SIMICS_TRACER_HPP_INCLUDED
#define FLEXUS_DECOUPLED_FEEDER_SIMICS_TRACER_HPP_INCLUDED

#include <components/Common/Slices/MemoryMessage.hpp>

namespace nDecoupledFeeder {

using Flexus::SharedTypes::MemoryMessage;

struct SimicsTracerManager {
  static SimicsTracerManager * construct(int32_t aNumCPUs
                                         , boost::function< void(int, MemoryMessage &) > toL1D
                                         , boost::function< void(int, MemoryMessage &, uint32_t) > toL1I
                                         , boost::function< void(MemoryMessage &) > toDMA
                                         , boost::function< void(int, MemoryMessage &) > toNAW
                                         , bool aWhiteBoxDebug
                                         , int32_t aWhiteBoxPeriod
                                        );
  virtual ~SimicsTracerManager()  {}
  virtual void setSimicsQuantum(int64_t aQuantum)  = 0;
  virtual void enableInstructionTracing() = 0;
  virtual void setSystemTick(double aTickFreq) = 0;
  virtual void updateStats() = 0;
};

}

#endif //FLEXUS_DECOUPLED_FEEDER_SIMICS_TRACER_HPP_INCLUDED
